Attribute VB_Name = "modRegistry"
Option Explicit

'Deklaration API-Konstanten
Private Const HKEY_LOCAL_MACHINE = &H80000002

Private Const REG_SZ = 1

'Deklaration API-Funktionen
Private Declare Function RegCloseKey Lib "advapi32.dll" ( _
  ByVal hKey As Long) As Long
  
Private Declare Function RegDeleteValue Lib "advapi32.dll" _
  Alias "RegDeleteValueA" (ByVal hKey As Long, _
  ByVal lpValueName As String) As Long
  
Private Declare Function RegOpenKey Lib "advapi32.dll" _
  Alias "RegOpenKeyA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, phkResult As Long) As Long
  
Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
  Alias "RegQueryValueExA" (ByVal hKey As Long, _
  ByVal lpValueName As String, ByVal lpReserved As Long, _
  lpType As Long, lpData As Any, lpcbData As Long) As Long
  
Private Declare Function RegSetValueEx Lib "advapi32.dll" _
  Alias "RegSetValueExA" (ByVal hKey As Long, _
  ByVal lpValueName As String, ByVal Reserved As Long, _
  ByVal dwType As Long, lpData As Any, _
  ByVal cbData As Long) As Long

Public Function DeleteAutoLogin() As Boolean
    'Deklaration Variablen
    Dim hKey As Long
    
    'Werte fr "AutoLogin" aus der Registry entfernen
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows " & _
      "nt\currentversion\winlogon", hKey
    RegDeleteValue hKey, "AutoLogin"
    RegDeleteValue hKey, "DefaultPassword"
    RegCloseKey hKey
End Function

Public Function DeleteAutoRun(sValueName As String) As Boolean
    'Deklaration Variablen
    Dim hKey As Long
    
    'Werte fr "Run" aus der Registry entfernen
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows\" & _
      "currentversion\run", hKey
    RegDeleteValue hKey, sValueName
    RegCloseKey hKey
End Function

Public Function DeleteAutoRunOnce(sValueName As String) As Boolean
    'Deklaration Variablen
    Dim hKey As Long
    
    'Werte fr "RunOnce" aus der Registry entfernen
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows\" & _
      "currentversion\runonce", hKey
    RegDeleteValue hKey, sValueName
    RegCloseKey hKey
End Function

Public Function GetDefaultUsername() As String
    'Deklaration Variablen
    Dim hKey As Long
    Dim lBuffer As Long
    Dim lRes As Long
    
    Dim sUsername As String
    
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows " & _
      "nt\currentversion\winlogon", hKey
    
    lRes = RegQueryValueEx(hKey, "DefaultUserName", 0, REG_SZ, _
      ByVal 0, lBuffer)
      
    If lRes = 0 Then
        sUsername = String(lBuffer, Chr(0))
        
        lRes = RegQueryValueEx(hKey, "DefaultUsername", 0, 0, _
          ByVal sUsername, lBuffer)
          
        If lRes = 0 Then
            GetDefaultUsername = Replace(sUsername, Chr(0), "")
        End If
    End If
End Function

Public Function SetAutoLogin(sUsername As String, _
  sPassword As String) As Boolean
  
    'Deklaration Variablen
    Dim hKey As Long
    
    'Werte fr "AutoLogin" in die Registry eintragen
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows " & _
      "nt\currentversion\winlogon", hKey
      
    RegSetValueEx hKey, "AutoLogin", 0, REG_SZ, ByVal "1", Len("1")
    
    RegSetValueEx hKey, "DefaultUserName", 0, REG_SZ, _
      ByVal sUsername, Len(sUsername)
      
    RegSetValueEx hKey, "DefaultPassword", 0, REG_SZ, _
      ByVal sPassword, Len(sPassword)
    RegCloseKey hKey
End Function

Public Function SetAutoRun(sValueName As String, _
  sValue As String) As Boolean
  
    'Deklaration Variablen
    Dim hKey As Long
    
    'Werte fr "Run" in die Registry eintragen
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows\" & _
      "currentversion\run", hKey
      
    RegSetValueEx hKey, sValueName, 0, REG_SZ, ByVal sValue, _
      Len(sValue)
      
    RegCloseKey hKey
End Function

Public Function SetAutoRunOnce(sValueName As String, sValue As String) As Boolean
    'Deklaration Variablen
    Dim hKey As Long
    
    'Werte fr "RunOnce" in die Registry eintragen
    RegOpenKey HKEY_LOCAL_MACHINE, "software\microsoft\windows\" & _
      "currentversion\runonce", hKey
      
    RegSetValueEx hKey, sValueName, 0, REG_SZ, ByVal sValue, _
      Len(sValue)
      
    RegCloseKey hKey
End Function
